package edu.harvard.mgh.purcell.gplink.base_form;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 * An extention of JPanel that selects a .txt file.
 * @author Kathe Todd-Brown
 *
 */
@SuppressWarnings("serial")
public class TXTSelectPanel extends JPanel{

	/**
	 * provides a root that the file choosers are anchored to
	 */
	private Forms parent;
	
	/** 
	 * text field that hold the .txt file name
	 */
	public GeneralUtil.UpdatingTextField TXTname;
	
	/**
	 * flags weather this is filled with a valid value or not
	 */
	public boolean validInput;
	
	/**
	 * Create a document listener that checks the validity of the
	 * panel everytime something changes.
	 */
	private DocumentListener updatingOk_DL = new DocumentListener(){
		public void insertUpdate(DocumentEvent arg0) 
		{ checkValidInput(); }
		public void removeUpdate(DocumentEvent arg0) 
		{ checkValidInput(); }
		public void changedUpdate(DocumentEvent arg0) 
		{ checkValidInput(); }
	};
	
	/**
	 * Get the contribution of this panel to the command line
	 * @return a string with the file name
	 */
	public String getCommand(){
		String ans = "";
		//check to see if it's valid
		if(validInput == true){
			//add the file name to the command
			ans = parent.processFilename(TXTname.getText());
		}
		//return that command component
		return ans;
	}
	
	/**
	 * If the field has something in it then flag it
	 * as valid and check the parent so that the ok button
	 * can be updated if the form is valid.
	 */
	private void checkValidInput(){
		if(TXTname.getText().length() != 0)
			validInput = true;
		else
			validInput = false;
		
		parent.isValidCommand();
	}
	
	/**
	 * Constructer
	 * @param p A Forms that this panel is contained in.
	 */
	public TXTSelectPanel(Forms p){

		parent = p;
		
		//set the sizes and content of the fileds that hold the
		//...input files
		TXTname = new GeneralUtil.UpdatingTextField(30, updatingOk_DL);
		
		//set up buttons to trigger the previously mentioned file chooser
		GeneralUtil.pickAFileButton selectTXT = 
			new GeneralUtil.pickAFileButton(".txt", "TXT", TXTname, parent);
				
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.ipady = 0;
		c.ipadx = 2;
		c.weighty = 0;
		c.weightx = 0;
		c.fill = GridBagConstraints.HORIZONTAL; 
		add(new JLabel(".txt file:"), c);
		c.gridx = 1;
		c.weightx = 1;
		add(TXTname, c);
		c.gridx=2;
		c.weightx = 0;
		add(selectTXT, c);
	}


}
