package edu.harvard.mgh.purcell.gplink.forms;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JSeparator;
import javax.swing.SwingConstants;

import edu.harvard.mgh.purcell.gplink.mainGUI.*;
import edu.harvard.mgh.purcell.gplink.base_form.Forms;

@SuppressWarnings("serial")
public class T2AssocForm extends Forms {

	Forms.myRadioButton t2Button, setButton;
	Forms.myCheckBox mpButton, //pButton, 
				setMinButton, setMaxButton;
	Forms.myJTextField setText, mpText, setMinText, setMaxText;
	Forms.pickAFileButton setBrowse;
	
	public T2AssocForm(MainFrame mf) {
		super(mf, "Set-based Association Tests");
	}

	@Override
	protected void createBody() {

		body.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridwidth = 2;
		body.add(new JLabel("SET file selection (--set)"),c);
		c.gridwidth = 1;
		c.weightx = 1;
		c.gridy = 1;
		body.add(setText, c);
		c.weightx = 0;
		c.gridx = 1;
		body.add(setBrowse,c);
		c.weightx = 0;
		c.gridy = 2;
		c.gridx = 0;
		body.add(new JLabel("max(T) permutaion mode (--mperm)"), c);
		c.weightx = 1;
		c.gridx = 1;
		body.add(mpText, c);
		c.gridx = 0;
		c.gridy = 3;
		c.gridwidth = 2;
		body.add(new JSeparator(SwingConstants.HORIZONTAL), c);
		c.weightx = 1;
		c.gridwidth = 2;
		c.gridx = 0;
		c.gridy = 4;
		body.add(t2Button, c);
		c.gridy = 5;
		body.add(setButton, c);
		c.gridy = 6;
		body.add(new JSeparator(SwingConstants.HORIZONTAL), c);
		c.gridwidth = 1;
		c.gridy = 7;
		body.add(setMinButton, c);
		c.gridx = 1;
		body.add(setMinText, c);
		c.gridy = 8;
		c.gridx = 0;
		body.add(setMaxButton, c);
		c.gridx = 1;
		body.add(setMaxText, c);
		
		/*c.gridwidth = 1;
		c.gridy = 9;
		body.add(mpButton, c);
		c.gridx = 1;
		body.add(mpText, c);
		*///c.gridx = 0;
		//c.gridy = 9;
		//body.add(pButton, c);
	}

	@Override
	protected String processBody() {
		
		String ans = " --set " + processFilename(setText.getText());

		ans += " --mperm " + mpText.getText();
		
		if(t2Button.isSelected())
			ans += " --T2";
		if(setButton.isSelected())
			ans += " --assoc";
		
		//if(mpButton.isSelected())
		//	ans += " --mperm " + mpText.getText();
		
		//if(pButton.isSelected())
		//	ans += " --perm";

		if(setMinButton.isSelected())
			ans += " --set-min " + setMinText.getText();
		
		if(setMaxButton.isSelected())
			ans += " --set-max " + setMaxText.getText();

		return ans;
	}

	@Override
	protected boolean isBodyValid() {
		if(setText.getText().length() == 0){
//			information.setText("Must have a valid file for --set.");
			return false;
		}
		
		if(!(mpText.getText().matches("\\d+"))){
//			information.setText("Fill in a valid --mperm value.");
			return false;
		}
		return true;
		/*
		return (new File(processFilename(setText.getText())).exists()
		    && ( t2Button.isSelected()  || 
		    	 (setButton.isSelected() && mpButton.isSelected() ) ) );
	*/
	}

	@Override
	protected void initalize() {
		setMinText = new myJTextField(10);
		setMaxText = new myJTextField(10);
		mpText = new myJTextField(10);
		setText = new myJTextField(20);
		setBrowse = new Forms.pickAFileButton(".set", "SET", setText);
		
		t2Button = new myRadioButton("Hotelling's T(2) for C/C (--T2)");
		setButton = new myRadioButton("Set-based association test (--assoc)");
		
		//pButton = new myCheckBox("Adaptive permutation mode (--perm)");
		mpButton = new myCheckBox("max(T) permutaion mode (--mperm)", mpText);
		mpButton.setSelected(true);
		mpButton.setEnabled(false);
		setMinButton = new myCheckBox("Minimum # SNPs in set (--set-min)",
				setMinText);
		setMaxButton = new myCheckBox("Maximum # SNPs in set (--set-max)", 
				setMaxText);

		ButtonGroup g1 = new ButtonGroup();
		g1.add(t2Button);
		t2Button.setSelected(true);
		g1.add(setButton);
	
		/*	public void actionPerformed(ActionEvent e) {
				if(mpButton.isSelected())
		//			pButton.setSelected(false);
			}
		};
		
		ActionListener changeMperm = new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if(pButton.isSelected())
					mpButton.setSelected(false);
			}
		};
		
		pButton.addActionListener(changeMperm);
		mpButton.addActionListener(changePerm);
		*/
	}

}
